// Code generated by mockery v2.52.2. DO NOT EDIT.

package patch

import mock "github.com/stretchr/testify/mock"

// MockOpParser is an autogenerated mock type for the OpParser type
type MockOpParser struct {
	mock.Mock
}

type MockOpParser_Expecter struct {
	mock *mock.Mock
}

func (_m *MockOpParser) EXPECT() *MockOpParser_Expecter {
	return &MockOpParser_Expecter{mock: &_m.Mock}
}

// Execute provides a mock function with given fields: op, args
func (_m *MockOpParser) Execute(op string, args []string) error {
	ret := _m.Called(op, args)

	if len(ret) == 0 {
		panic("no return value specified for Execute")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(string, []string) error); ok {
		r0 = rf(op, args)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockOpParser_Execute_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Execute'
type MockOpParser_Execute_Call struct {
	*mock.Call
}

// Execute is a helper method to define mock.On call
//   - op string
//   - args []string
func (_e *MockOpParser_Expecter) Execute(op interface{}, args interface{}) *MockOpParser_Execute_Call {
	return &MockOpParser_Execute_Call{Call: _e.mock.On("Execute", op, args)}
}

func (_c *MockOpParser_Execute_Call) Run(run func(op string, args []string)) *MockOpParser_Execute_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(string), args[1].([]string))
	})
	return _c
}

func (_c *MockOpParser_Execute_Call) Return(_a0 error) *MockOpParser_Execute_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockOpParser_Execute_Call) RunAndReturn(run func(string, []string) error) *MockOpParser_Execute_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockOpParser creates a new instance of MockOpParser. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockOpParser(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockOpParser {
	mock := &MockOpParser{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
